import { InputMutations } from './function-mutates-input';
/**
 * Error thrown when a method is marked as immutable but modifies its input values.
 */
export declare class MethodNotImmutableError extends Error {
    readonly method: string;
    readonly class: string | undefined;
    readonly diff: string;
    constructor(mutations: InputMutations, originalMethod: Function, originalConstructor?: Function, methodName?: string);
    toString(): string;
}
/**
 * Format an array as javascript property paths.
 * @example
 *     pathTo(['list', '3', 'id']) // => ".list[3].id"
 * @internal
 */
export declare function pathToString(path: string[]): string;
