import { TrackedMethodCall, Subscribable } from './immutable-interfaces';
/**
 * Get notified when a method of an @Immutable class instance is called and of any changed properties.
 * To use the rxjs observables your project uses, you need to pass the `Observable` class.
 */
export declare function observeImmutable<T, O extends Subscribable<TrackedMethodCall<T>>>(instance: T, observableClass: {
    new (): O;
}): O;
/**
 * Get notified when a method of an @Immutable class instance is called and of any changed properties.
 */
export declare function observeImmutable<T>(instance: T): Subscribable<TrackedMethodCall<T>>;
/**
 * Creates an observable of a passed Implementation or a plain-JavaScript observable.
 * @internal
 */
export declare function createObservable<T>(observerList: Array<(emittedValue: T) => void>, observableClass: any): Subscribable<T>;
