import { ImmutableClassMetadata, ImmutableInstanceMetadata } from './immutable-interfaces';
/** @internal */
export declare function getFunctionName(fn: Function, prototype?: any): string;
/** @internal */
export declare function getFunctionArgs(fn: Function): string[];
/**
 * Parses functions and arrows functions to get the function name and argument names.
 * @internal
 */
export declare function parseFunctionSource(source: string): {
    name: string;
    argNames: string[];
};
/** @internal */
export declare function getImmutableClassMetadata(target: Function): Partial<ImmutableClassMetadata> | undefined;
/** @internal */
export declare function setImmutableClassMetadata(target: Function, data: Partial<ImmutableClassMetadata>): void;
/** @internal */
export declare function getInstanceMetadata(target: any): ImmutableInstanceMetadata | undefined;
/** @internal */
export declare function setInitialInstanceMetadata(target: any): void;
/** @internal Short-hand method for Array.prototype.slice(). */
export declare const arraySlice: <T>(arr: T[]) => T[];
/** @internal Short-hand method for Object.hasOwnProperty(). */
export declare const hasOwnProperty: (obj: any, prop: string) => obj is typeof obj & {
};
/** @internal Short-hand method for Array.isArray(). */
export declare const isArray: (arg: any) => arg is any[];
/** @internal Short-hand method for Object.keys(). */
export declare const objectKeys: (o: any) => string[];
/** @internal Short-hand method for Object.assign(). */
export declare const objectAssign: {
    <T, U>(target: T, source: U): T & U;
    <T, U, V>(target: T, source1: U, source2: V): T & U & V;
    <T, U, V, W>(target: T, source1: U, source2: V, source3: W): T & U & V & W;
    (target: any, ...sources: any[]): any;
};
/** @internal Short-hand method for Object.assign(). */
export declare const objectCreate: {
    (o: object): any;
    (o: object, properties: PropertyDescriptorMap): any;
};
/** @internal Short-hand method for Object.defineProperty(). */
export declare const objectDefineProperty: {
    (o: any, p: string, attributes: PropertyDescriptor): any;
    (o: any, propertyKey: PropertyKey, attributes: PropertyDescriptor): any;
};
/** @internal Short-hand method for Object.getPrototypeOf(). */
export declare const objectGetPrototypeOf: (o: any) => any;
